<%
/**
 *     Copyright (C) 2009-2011  Jack A. Rider All rights reserved.
 * 
 *     This program is free software: you can redistribute it and/or modify
 *     it under the terms of the GNU General Public License as published by
 *     the Free Software Foundation, either version 3 of the License, or
 *     (at your option) any later version.
 * 
 *     This program is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *     GNU General Public License for more details.
 */
%> 
<%@include file="../init.jsp" %>

<%@ page import="org.xmlportletfactory.portal.goodclient.model.userTypes" %>
<%@ page import="org.xmlportletfactory.portal.goodclient.service.userTypesLocalServiceUtil" %>

<%@ page import="com.liferay.portlet.PortalPreferences" %>
<%@ page import="com.liferay.portal.kernel.util.Validator" %>
<%@ page import="com.liferay.portal.kernel.util.OrderByComparator" %>
<%@ page import="org.xmlportletfactory.portal.goodclient.UserTypesComparator" %>

<jsp:useBean id="addUserTypesURL" class="java.lang.String" scope="request" />
<jsp:useBean id="userTypesFilterURL" class="java.lang.String" scope="request" />
<jsp:useBean id="userTypesFilter" class="java.lang.String" scope="request" />
<link rel="stylesheet" type="text/css" href="/xmlpfexampleL-portlet/css/Portlet_UserTypes.css" />
<liferay-ui:success key="userTypes-prefs-success" message="userTypes-prefs-success" />
<liferay-ui:success key="userTypes-added-successfully" message="userTypes-added-successfully" />
<liferay-ui:success key="userTypes-deleted-successfully" message="userTypes-deleted-successfully" />
<liferay-ui:success key="userTypes-updated-successfully" message="userTypes-updated-successfully" />
<c:choose>
	<c:when test='<%= (Boolean)request.getAttribute("hasAddPermission") %>'>
		<input type="button" name="addUserTypesButton" value="<liferay-ui:message key="userTypes-add" />" onClick="self.location = '<%=addUserTypesURL %>';">
	</c:when>
</c:choose>


<form id="userTypesFilterForm" name="userTypesFilterForm" action="<%=userTypesFilterURL %>" method="POST">
	<input type="text" name="userTypesFilter" value="<%= userTypesFilter %>" />
	<input type="submit" value="<liferay-ui:message key="filter" />">
</form>
<%
	String iconChecked = "checked";
	String iconUnchecked = "unchecked";
	int rows_per_page = new Integer(prefs.getValue("userTypes-rows-per-page", "5"));
	if (Validator.isNotNull(userTypesFilter) || !userTypesFilter.equalsIgnoreCase("")) {
		rows_per_page = 100;
	}
	
	SimpleDateFormat dateFormat = new SimpleDateFormat(prefs.getValue("userTypes-date-format", "yyyy/MM/dd"));
	SimpleDateFormat dateTimeFormat = new SimpleDateFormat(prefs.getValue("userTypes-datetime-format","yyyy/MM/dd HH:mm"));

	PortalPreferences portalPrefs = PortletPreferencesFactoryUtil.getPortalPreferences(request);

	String orderByCol = ParamUtil.getString(request, "orderByCol");
	String orderByType = ParamUtil.getString(request, "orderByType");

	if (Validator.isNotNull(orderByCol) && Validator.isNotNull(orderByType)) {
		portalPrefs.setValue("userTypes_order", "userTypes-order-by-col", orderByCol);
		portalPrefs.setValue("userTypes_order", "userTypes-order-by-type", orderByType);
	} else {
		orderByCol = portalPrefs.getValue("userTypes_order", "userTypes-order-by-col", "userTypeId");
		orderByType = portalPrefs.getValue("userTypes_order", "userTypes-order-by-type", "asc");
	}
%>
<liferay-ui:search-container  delta='<%= rows_per_page %>' emptyResultsMessage="userTypes-empty-results-message" orderByCol="<%= orderByCol%>" orderByType="<%= orderByType%>">
	<liferay-ui:search-container-results>

		<%
		List<userTypes> tempResults = (List<userTypes>)request.getAttribute("tempResults");
		results = ListUtil.subList(tempResults, searchContainer.getStart(), searchContainer.getEnd());
		total = tempResults.size();

		pageContext.setAttribute("results", results);
		pageContext.setAttribute("total", total);
		%>

	</liferay-ui:search-container-results>

	<liferay-ui:search-container-row
		className="org.xmlportletfactory.portal.goodclient.model.userTypes"
		keyProperty="userTypeId"
		modelVar="userTypes"
	>

		<liferay-ui:search-container-column-text
			name="Id"
		    property="userTypeId"
			orderable="true"
			orderableProperty="userTypeId"
			align="right"
		/>
		<liferay-ui:search-container-column-text
			name="Description"
			property="userTypeDescription"
			orderable="true"
			orderableProperty="userTypeDescription"
			align="left"
		/>
		<liferay-ui:search-container-column-jsp
			align="right"
			path="/JSPs/userTypes/edit_actions.jsp"
		/>

	</liferay-ui:search-container-row>

	<liferay-ui:search-iterator />

</liferay-ui:search-container>
