/**
 * Copyright (c) 2000-2011 Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package org.xmlportletfactory.portal.goodclient.model;

import com.liferay.portal.kernel.bean.AutoEscapeBeanHandler;
import com.liferay.portal.kernel.exception.SystemException;
import com.liferay.portal.kernel.util.StringBundler;
import com.liferay.portal.model.impl.BaseModelImpl;
import com.liferay.portal.util.PortalUtil;

import java.io.Serializable;

import java.lang.reflect.Proxy;

/**
 * @author Jack A. Rider
 */
public class userTypesClp extends BaseModelImpl<userTypes> implements userTypes {
	public userTypesClp() {
	}

	public long getPrimaryKey() {
		return _userTypeId;
	}

	public void setPrimaryKey(long pk) {
		setUserTypeId(pk);
	}

	public Serializable getPrimaryKeyObj() {
		return new Long(_userTypeId);
	}

	public long getUserTypeId() {
		return _userTypeId;
	}

	public void setUserTypeId(long userTypeId) {
		_userTypeId = userTypeId;
	}

	public long getCompanyId() {
		return _companyId;
	}

	public void setCompanyId(long companyId) {
		_companyId = companyId;
	}

	public long getGroupId() {
		return _groupId;
	}

	public void setGroupId(long groupId) {
		_groupId = groupId;
	}

	public long getUserId() {
		return _userId;
	}

	public void setUserId(long userId) {
		_userId = userId;
	}

	public String getUserUuid() throws SystemException {
		return PortalUtil.getUserValue(getUserId(), "uuid", _userUuid);
	}

	public void setUserUuid(String userUuid) {
		_userUuid = userUuid;
	}

	public String getUserTypeDescription() {
		return _userTypeDescription;
	}

	public void setUserTypeDescription(String userTypeDescription) {
		_userTypeDescription = userTypeDescription;
	}

	public userTypes toEscapedModel() {
		if (isEscapedModel()) {
			return this;
		}
		else {
			return (userTypes)Proxy.newProxyInstance(userTypes.class.getClassLoader(),
				new Class[] { userTypes.class }, new AutoEscapeBeanHandler(this));
		}
	}

	public Object clone() {
		userTypesClp clone = new userTypesClp();

		clone.setUserTypeId(getUserTypeId());
		clone.setCompanyId(getCompanyId());
		clone.setGroupId(getGroupId());
		clone.setUserId(getUserId());
		clone.setUserTypeDescription(getUserTypeDescription());

		return clone;
	}

	public int compareTo(userTypes userTypes) {
		long pk = userTypes.getPrimaryKey();

		if (getPrimaryKey() < pk) {
			return -1;
		}
		else if (getPrimaryKey() > pk) {
			return 1;
		}
		else {
			return 0;
		}
	}

	public boolean equals(Object obj) {
		if (obj == null) {
			return false;
		}

		userTypesClp userTypes = null;

		try {
			userTypes = (userTypesClp)obj;
		}
		catch (ClassCastException cce) {
			return false;
		}

		long pk = userTypes.getPrimaryKey();

		if (getPrimaryKey() == pk) {
			return true;
		}
		else {
			return false;
		}
	}

	public int hashCode() {
		return (int)getPrimaryKey();
	}

	public String toString() {
		StringBundler sb = new StringBundler(11);

		sb.append("{userTypeId=");
		sb.append(getUserTypeId());
		sb.append(", companyId=");
		sb.append(getCompanyId());
		sb.append(", groupId=");
		sb.append(getGroupId());
		sb.append(", userId=");
		sb.append(getUserId());
		sb.append(", userTypeDescription=");
		sb.append(getUserTypeDescription());
		sb.append("}");

		return sb.toString();
	}

	public String toXmlString() {
		StringBundler sb = new StringBundler(19);

		sb.append("<model><model-name>");
		sb.append("org.xmlportletfactory.portal.goodclient.model.userTypes");
		sb.append("</model-name>");

		sb.append(
			"<column><column-name>userTypeId</column-name><column-value><![CDATA[");
		sb.append(getUserTypeId());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>companyId</column-name><column-value><![CDATA[");
		sb.append(getCompanyId());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>groupId</column-name><column-value><![CDATA[");
		sb.append(getGroupId());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>userId</column-name><column-value><![CDATA[");
		sb.append(getUserId());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>userTypeDescription</column-name><column-value><![CDATA[");
		sb.append(getUserTypeDescription());
		sb.append("]]></column-value></column>");

		sb.append("</model>");

		return sb.toString();
	}

	private long _userTypeId;
	private long _companyId;
	private long _groupId;
	private long _userId;
	private String _userUuid;
	private String _userTypeDescription;
}