/**
 * Copyright (c) 2000-2011 Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package org.xmlportletfactory.portal.goodclient.model;

import com.liferay.portal.kernel.annotation.AutoEscape;
import com.liferay.portal.kernel.exception.SystemException;
import com.liferay.portal.model.BaseModel;
import com.liferay.portal.service.ServiceContext;

import com.liferay.portlet.expando.model.ExpandoBridge;

import java.io.Serializable;

/**
 * The base model interface for the userTypes service. Represents a row in the &quot;xmlpfexamplel_userTypes&quot; database table, with each column mapped to a property of this class.
 *
 * <p>
 * This interface and its corresponding implementation {@link org.xmlportletfactory.portal.goodclient.model.impl.userTypesModelImpl} exist only as a container for the default property accessors generated by ServiceBuilder. Helper methods and all application logic should be put in {@link org.xmlportletfactory.portal.goodclient.model.impl.userTypesImpl}.
 * </p>
 *
 * <p>
 * Never modify or reference this interface directly. All methods that expect a user types model instance should use the {@link userTypes} interface instead.
 * </p>
 *
 * @author Jack A. Rider
 * @see userTypes
 * @see org.xmlportletfactory.portal.goodclient.model.impl.userTypesImpl
 * @see org.xmlportletfactory.portal.goodclient.model.impl.userTypesModelImpl
 * @generated
 */
public interface userTypesModel extends BaseModel<userTypes> {
	/**
	 * Gets the primary key of this user types.
	 *
	 * @return the primary key of this user types
	 */
	public long getPrimaryKey();

	/**
	 * Sets the primary key of this user types
	 *
	 * @param pk the primary key of this user types
	 */
	public void setPrimaryKey(long pk);

	/**
	 * Gets the user type id of this user types.
	 *
	 * @return the user type id of this user types
	 */
	public long getUserTypeId();

	/**
	 * Sets the user type id of this user types.
	 *
	 * @param userTypeId the user type id of this user types
	 */
	public void setUserTypeId(long userTypeId);

	/**
	 * Gets the company id of this user types.
	 *
	 * @return the company id of this user types
	 */
	public long getCompanyId();

	/**
	 * Sets the company id of this user types.
	 *
	 * @param companyId the company id of this user types
	 */
	public void setCompanyId(long companyId);

	/**
	 * Gets the group id of this user types.
	 *
	 * @return the group id of this user types
	 */
	public long getGroupId();

	/**
	 * Sets the group id of this user types.
	 *
	 * @param groupId the group id of this user types
	 */
	public void setGroupId(long groupId);

	/**
	 * Gets the user id of this user types.
	 *
	 * @return the user id of this user types
	 */
	public long getUserId();

	/**
	 * Sets the user id of this user types.
	 *
	 * @param userId the user id of this user types
	 */
	public void setUserId(long userId);

	/**
	 * Gets the user uuid of this user types.
	 *
	 * @return the user uuid of this user types
	 * @throws SystemException if a system exception occurred
	 */
	public String getUserUuid() throws SystemException;

	/**
	 * Sets the user uuid of this user types.
	 *
	 * @param userUuid the user uuid of this user types
	 */
	public void setUserUuid(String userUuid);

	/**
	 * Gets the user type description of this user types.
	 *
	 * @return the user type description of this user types
	 */
	@AutoEscape
	public String getUserTypeDescription();

	/**
	 * Sets the user type description of this user types.
	 *
	 * @param userTypeDescription the user type description of this user types
	 */
	public void setUserTypeDescription(String userTypeDescription);

	/**
	 * Gets a copy of this user types as an escaped model instance by wrapping it with an {@link com.liferay.portal.kernel.bean.AutoEscapeBeanHandler}.
	 *
	 * @return the escaped model instance
	 * @see com.liferay.portal.kernel.bean.AutoEscapeBeanHandler
	 */
	public userTypes toEscapedModel();

	public boolean isNew();

	public void setNew(boolean n);

	public boolean isCachedModel();

	public void setCachedModel(boolean cachedModel);

	public boolean isEscapedModel();

	public void setEscapedModel(boolean escapedModel);

	public Serializable getPrimaryKeyObj();

	public ExpandoBridge getExpandoBridge();

	public void setExpandoBridgeAttributes(ServiceContext serviceContext);

	public Object clone();

	public int compareTo(userTypes userTypes);

	public int hashCode();

	public String toString();

	public String toXmlString();
}