/**
 * Copyright (c) 2000-2011 Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package org.xmlportletfactory.portal.goodclient.model.impl;

import com.liferay.portal.kernel.bean.AutoEscapeBeanHandler;
import com.liferay.portal.kernel.exception.SystemException;
import com.liferay.portal.kernel.util.GetterUtil;
import com.liferay.portal.kernel.util.StringBundler;
import com.liferay.portal.kernel.util.StringPool;
import com.liferay.portal.model.impl.BaseModelImpl;
import com.liferay.portal.service.ServiceContext;
import com.liferay.portal.util.PortalUtil;

import com.liferay.portlet.expando.model.ExpandoBridge;
import com.liferay.portlet.expando.util.ExpandoBridgeFactoryUtil;

import org.xmlportletfactory.portal.goodclient.model.userTypes;
import org.xmlportletfactory.portal.goodclient.model.userTypesModel;

import java.io.Serializable;

import java.lang.reflect.Proxy;

import java.sql.Types;

/**
 * The base model implementation for the userTypes service. Represents a row in the &quot;xmlpfexamplel_userTypes&quot; database table, with each column mapped to a property of this class.
 *
 * <p>
 * This implementation and its corresponding interface {@link org.xmlportletfactory.portal.goodclient.model.userTypesModel} exist only as a container for the default property accessors generated by ServiceBuilder. Helper methods and all application logic should be put in {@link userTypesImpl}.
 * </p>
 *
 * <p>
 * Never modify or reference this class directly. All methods that expect a user types model instance should use the {@link org.xmlportletfactory.portal.goodclient.model.userTypes} interface instead.
 * </p>
 *
 * @author Jack A. Rider
 * @see userTypesImpl
 * @see org.xmlportletfactory.portal.goodclient.model.userTypes
 * @see org.xmlportletfactory.portal.goodclient.model.userTypesModel
 * @generated
 */
public class userTypesModelImpl extends BaseModelImpl<userTypes>
	implements userTypesModel {
	public static final String TABLE_NAME = "xmlpfexamplel_userTypes";
	public static final Object[][] TABLE_COLUMNS = {
			{ "userTypeId", new Integer(Types.BIGINT) },
			{ "companyId", new Integer(Types.BIGINT) },
			{ "groupId", new Integer(Types.BIGINT) },
			{ "userId", new Integer(Types.BIGINT) },
			{ "userTypeDescription", new Integer(Types.VARCHAR) }
		};
	public static final String TABLE_SQL_CREATE = "create table xmlpfexamplel_userTypes (userTypeId LONG not null primary key,companyId LONG,groupId LONG,userId LONG,userTypeDescription VARCHAR(30) null)";
	public static final String TABLE_SQL_DROP = "drop table xmlpfexamplel_userTypes";
	public static final String DATA_SOURCE = "liferayDataSource";
	public static final String SESSION_FACTORY = "liferaySessionFactory";
	public static final String TX_MANAGER = "liferayTransactionManager";
	public static final boolean ENTITY_CACHE_ENABLED = GetterUtil.getBoolean(com.liferay.util.service.ServiceProps.get(
				"value.object.entity.cache.enabled.org.xmlportletfactory.portal.goodclient.model.userTypes"),
			true);
	public static final boolean FINDER_CACHE_ENABLED = GetterUtil.getBoolean(com.liferay.util.service.ServiceProps.get(
				"value.object.finder.cache.enabled.org.xmlportletfactory.portal.goodclient.model.userTypes"),
			true);
	public static final long LOCK_EXPIRATION_TIME = GetterUtil.getLong(com.liferay.util.service.ServiceProps.get(
				"lock.expiration.time.org.xmlportletfactory.portal.goodclient.model.userTypes"));

	public userTypesModelImpl() {
	}

	public long getPrimaryKey() {
		return _userTypeId;
	}

	public void setPrimaryKey(long pk) {
		setUserTypeId(pk);
	}

	public Serializable getPrimaryKeyObj() {
		return new Long(_userTypeId);
	}

	public long getUserTypeId() {
		return _userTypeId;
	}

	public void setUserTypeId(long userTypeId) {
		_userTypeId = userTypeId;
	}

	public long getCompanyId() {
		return _companyId;
	}

	public void setCompanyId(long companyId) {
		_companyId = companyId;
	}

	public long getGroupId() {
		return _groupId;
	}

	public void setGroupId(long groupId) {
		_groupId = groupId;
	}

	public long getUserId() {
		return _userId;
	}

	public void setUserId(long userId) {
		_userId = userId;
	}

	public String getUserUuid() throws SystemException {
		return PortalUtil.getUserValue(getUserId(), "uuid", _userUuid);
	}

	public void setUserUuid(String userUuid) {
		_userUuid = userUuid;
	}

	public String getUserTypeDescription() {
		if (_userTypeDescription == null) {
			return StringPool.BLANK;
		}
		else {
			return _userTypeDescription;
		}
	}

	public void setUserTypeDescription(String userTypeDescription) {
		_userTypeDescription = userTypeDescription;
	}

	public userTypes toEscapedModel() {
		if (isEscapedModel()) {
			return (userTypes)this;
		}
		else {
			return (userTypes)Proxy.newProxyInstance(userTypes.class.getClassLoader(),
				new Class[] { userTypes.class }, new AutoEscapeBeanHandler(this));
		}
	}

	public ExpandoBridge getExpandoBridge() {
		if (_expandoBridge == null) {
			_expandoBridge = ExpandoBridgeFactoryUtil.getExpandoBridge(getCompanyId(),
					userTypes.class.getName(), getPrimaryKey());
		}

		return _expandoBridge;
	}

	public void setExpandoBridgeAttributes(ServiceContext serviceContext) {
		getExpandoBridge().setAttributes(serviceContext);
	}

	public Object clone() {
		userTypesImpl userTypesImpl = new userTypesImpl();

		userTypesImpl.setUserTypeId(getUserTypeId());

		userTypesImpl.setCompanyId(getCompanyId());

		userTypesImpl.setGroupId(getGroupId());

		userTypesImpl.setUserId(getUserId());

		userTypesImpl.setUserTypeDescription(getUserTypeDescription());

		return userTypesImpl;
	}

	public int compareTo(userTypes userTypes) {
		long pk = userTypes.getPrimaryKey();

		if (getPrimaryKey() < pk) {
			return -1;
		}
		else if (getPrimaryKey() > pk) {
			return 1;
		}
		else {
			return 0;
		}
	}

	public boolean equals(Object obj) {
		if (obj == null) {
			return false;
		}

		userTypes userTypes = null;

		try {
			userTypes = (userTypes)obj;
		}
		catch (ClassCastException cce) {
			return false;
		}

		long pk = userTypes.getPrimaryKey();

		if (getPrimaryKey() == pk) {
			return true;
		}
		else {
			return false;
		}
	}

	public int hashCode() {
		return (int)getPrimaryKey();
	}

	public String toString() {
		StringBundler sb = new StringBundler(11);

		sb.append("{userTypeId=");
		sb.append(getUserTypeId());
		sb.append(", companyId=");
		sb.append(getCompanyId());
		sb.append(", groupId=");
		sb.append(getGroupId());
		sb.append(", userId=");
		sb.append(getUserId());
		sb.append(", userTypeDescription=");
		sb.append(getUserTypeDescription());
		sb.append("}");

		return sb.toString();
	}

	public String toXmlString() {
		StringBundler sb = new StringBundler(19);

		sb.append("<model><model-name>");
		sb.append("org.xmlportletfactory.portal.goodclient.model.userTypes");
		sb.append("</model-name>");

		sb.append(
			"<column><column-name>userTypeId</column-name><column-value><![CDATA[");
		sb.append(getUserTypeId());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>companyId</column-name><column-value><![CDATA[");
		sb.append(getCompanyId());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>groupId</column-name><column-value><![CDATA[");
		sb.append(getGroupId());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>userId</column-name><column-value><![CDATA[");
		sb.append(getUserId());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>userTypeDescription</column-name><column-value><![CDATA[");
		sb.append(getUserTypeDescription());
		sb.append("]]></column-value></column>");

		sb.append("</model>");

		return sb.toString();
	}

	private long _userTypeId;
	private long _companyId;
	private long _groupId;
	private long _userId;
	private String _userUuid;
	private String _userTypeDescription;
	private transient ExpandoBridge _expandoBridge;
}