/**
 * Copyright (c) 2000-2011 Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package org.xmlportletfactory.portal.goodclient.model.impl;

import com.liferay.portal.kernel.bean.AutoEscapeBeanHandler;
import com.liferay.portal.kernel.exception.SystemException;
import com.liferay.portal.kernel.util.GetterUtil;
import com.liferay.portal.kernel.util.StringBundler;
import com.liferay.portal.kernel.util.StringPool;
import com.liferay.portal.model.impl.BaseModelImpl;
import com.liferay.portal.service.ServiceContext;
import com.liferay.portal.util.PortalUtil;

import com.liferay.portlet.expando.model.ExpandoBridge;
import com.liferay.portlet.expando.util.ExpandoBridgeFactoryUtil;

import org.xmlportletfactory.portal.goodclient.model.users;
import org.xmlportletfactory.portal.goodclient.model.usersModel;

import java.io.Serializable;

import java.lang.reflect.Proxy;

import java.sql.Types;

/**
 * The base model implementation for the users service. Represents a row in the &quot;xmlpfexamplel_users&quot; database table, with each column mapped to a property of this class.
 *
 * <p>
 * This implementation and its corresponding interface {@link org.xmlportletfactory.portal.goodclient.model.usersModel} exist only as a container for the default property accessors generated by ServiceBuilder. Helper methods and all application logic should be put in {@link usersImpl}.
 * </p>
 *
 * <p>
 * Never modify or reference this class directly. All methods that expect a users model instance should use the {@link org.xmlportletfactory.portal.goodclient.model.users} interface instead.
 * </p>
 *
 * @author Jack A. Rider
 * @see usersImpl
 * @see org.xmlportletfactory.portal.goodclient.model.users
 * @see org.xmlportletfactory.portal.goodclient.model.usersModel
 * @generated
 */
public class usersModelImpl extends BaseModelImpl<users> implements usersModel {
	public static final String TABLE_NAME = "xmlpfexamplel_users";
	public static final Object[][] TABLE_COLUMNS = {
			{ "usersId", new Integer(Types.BIGINT) },
			{ "companyId", new Integer(Types.BIGINT) },
			{ "groupId", new Integer(Types.BIGINT) },
			{ "userId", new Integer(Types.BIGINT) },
			{ "userName", new Integer(Types.VARCHAR) },
			{ "userTypeId", new Integer(Types.BIGINT) }
		};
	public static final String TABLE_SQL_CREATE = "create table xmlpfexamplel_users (usersId LONG not null primary key,companyId LONG,groupId LONG,userId LONG,userName VARCHAR(30) null,userTypeId LONG)";
	public static final String TABLE_SQL_DROP = "drop table xmlpfexamplel_users";
	public static final String DATA_SOURCE = "liferayDataSource";
	public static final String SESSION_FACTORY = "liferaySessionFactory";
	public static final String TX_MANAGER = "liferayTransactionManager";
	public static final boolean ENTITY_CACHE_ENABLED = GetterUtil.getBoolean(com.liferay.util.service.ServiceProps.get(
				"value.object.entity.cache.enabled.org.xmlportletfactory.portal.goodclient.model.users"),
			true);
	public static final boolean FINDER_CACHE_ENABLED = GetterUtil.getBoolean(com.liferay.util.service.ServiceProps.get(
				"value.object.finder.cache.enabled.org.xmlportletfactory.portal.goodclient.model.users"),
			true);
	public static final long LOCK_EXPIRATION_TIME = GetterUtil.getLong(com.liferay.util.service.ServiceProps.get(
				"lock.expiration.time.org.xmlportletfactory.portal.goodclient.model.users"));

	public usersModelImpl() {
	}

	public long getPrimaryKey() {
		return _usersId;
	}

	public void setPrimaryKey(long pk) {
		setUsersId(pk);
	}

	public Serializable getPrimaryKeyObj() {
		return new Long(_usersId);
	}

	public long getUsersId() {
		return _usersId;
	}

	public void setUsersId(long usersId) {
		_usersId = usersId;
	}

	public long getCompanyId() {
		return _companyId;
	}

	public void setCompanyId(long companyId) {
		_companyId = companyId;
	}

	public long getGroupId() {
		return _groupId;
	}

	public void setGroupId(long groupId) {
		_groupId = groupId;
	}

	public long getUserId() {
		return _userId;
	}

	public void setUserId(long userId) {
		_userId = userId;
	}

	public String getUserUuid() throws SystemException {
		return PortalUtil.getUserValue(getUserId(), "uuid", _userUuid);
	}

	public void setUserUuid(String userUuid) {
		_userUuid = userUuid;
	}

	public String getUserName() {
		if (_userName == null) {
			return StringPool.BLANK;
		}
		else {
			return _userName;
		}
	}

	public void setUserName(String userName) {
		_userName = userName;
	}

	public long getUserTypeId() {
		return _userTypeId;
	}

	public void setUserTypeId(long userTypeId) {
		_userTypeId = userTypeId;
	}

	public users toEscapedModel() {
		if (isEscapedModel()) {
			return (users)this;
		}
		else {
			return (users)Proxy.newProxyInstance(users.class.getClassLoader(),
				new Class[] { users.class }, new AutoEscapeBeanHandler(this));
		}
	}

	public ExpandoBridge getExpandoBridge() {
		if (_expandoBridge == null) {
			_expandoBridge = ExpandoBridgeFactoryUtil.getExpandoBridge(getCompanyId(),
					users.class.getName(), getPrimaryKey());
		}

		return _expandoBridge;
	}

	public void setExpandoBridgeAttributes(ServiceContext serviceContext) {
		getExpandoBridge().setAttributes(serviceContext);
	}

	public Object clone() {
		usersImpl usersImpl = new usersImpl();

		usersImpl.setUsersId(getUsersId());

		usersImpl.setCompanyId(getCompanyId());

		usersImpl.setGroupId(getGroupId());

		usersImpl.setUserId(getUserId());

		usersImpl.setUserName(getUserName());

		usersImpl.setUserTypeId(getUserTypeId());

		return usersImpl;
	}

	public int compareTo(users users) {
		long pk = users.getPrimaryKey();

		if (getPrimaryKey() < pk) {
			return -1;
		}
		else if (getPrimaryKey() > pk) {
			return 1;
		}
		else {
			return 0;
		}
	}

	public boolean equals(Object obj) {
		if (obj == null) {
			return false;
		}

		users users = null;

		try {
			users = (users)obj;
		}
		catch (ClassCastException cce) {
			return false;
		}

		long pk = users.getPrimaryKey();

		if (getPrimaryKey() == pk) {
			return true;
		}
		else {
			return false;
		}
	}

	public int hashCode() {
		return (int)getPrimaryKey();
	}

	public String toString() {
		StringBundler sb = new StringBundler(13);

		sb.append("{usersId=");
		sb.append(getUsersId());
		sb.append(", companyId=");
		sb.append(getCompanyId());
		sb.append(", groupId=");
		sb.append(getGroupId());
		sb.append(", userId=");
		sb.append(getUserId());
		sb.append(", userName=");
		sb.append(getUserName());
		sb.append(", userTypeId=");
		sb.append(getUserTypeId());
		sb.append("}");

		return sb.toString();
	}

	public String toXmlString() {
		StringBundler sb = new StringBundler(22);

		sb.append("<model><model-name>");
		sb.append("org.xmlportletfactory.portal.goodclient.model.users");
		sb.append("</model-name>");

		sb.append(
			"<column><column-name>usersId</column-name><column-value><![CDATA[");
		sb.append(getUsersId());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>companyId</column-name><column-value><![CDATA[");
		sb.append(getCompanyId());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>groupId</column-name><column-value><![CDATA[");
		sb.append(getGroupId());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>userId</column-name><column-value><![CDATA[");
		sb.append(getUserId());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>userName</column-name><column-value><![CDATA[");
		sb.append(getUserName());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>userTypeId</column-name><column-value><![CDATA[");
		sb.append(getUserTypeId());
		sb.append("]]></column-value></column>");

		sb.append("</model>");

		return sb.toString();
	}

	private long _usersId;
	private long _companyId;
	private long _groupId;
	private long _userId;
	private String _userUuid;
	private String _userName;
	private long _userTypeId;
	private transient ExpandoBridge _expandoBridge;
}