/**
 * Copyright (c) 2000-2011 Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package org.xmlportletfactory.portal.goodclient.service.base;

import com.liferay.counter.service.CounterLocalService;

import com.liferay.portal.kernel.annotation.BeanReference;
import com.liferay.portal.kernel.dao.jdbc.SqlUpdate;
import com.liferay.portal.kernel.dao.jdbc.SqlUpdateFactoryUtil;
import com.liferay.portal.kernel.dao.orm.DynamicQuery;
import com.liferay.portal.kernel.exception.PortalException;
import com.liferay.portal.kernel.exception.SystemException;
import com.liferay.portal.kernel.util.OrderByComparator;
import com.liferay.portal.service.ResourceLocalService;
import com.liferay.portal.service.ResourceService;
import com.liferay.portal.service.UserLocalService;
import com.liferay.portal.service.UserService;
import com.liferay.portal.service.persistence.ResourcePersistence;
import com.liferay.portal.service.persistence.UserPersistence;

import org.xmlportletfactory.portal.goodclient.model.userTypes;
import org.xmlportletfactory.portal.goodclient.service.persistence.userTypesPersistence;
import org.xmlportletfactory.portal.goodclient.service.persistence.usersPersistence;
import org.xmlportletfactory.portal.goodclient.service.userTypesLocalService;
import org.xmlportletfactory.portal.goodclient.service.usersLocalService;

import java.util.List;

import javax.sql.DataSource;

/**
 * The base implementation of the user types local service.
 *
 * <p>
 * This implementation exists only as a container for the default service methods generated by ServiceBuilder. All custom service methods should be put in {@link org.xmlportletfactory.portal.goodclient.service.impl.userTypesLocalServiceImpl}.
 * </p>
 *
 * <p>
 * Never modify or reference this class directly. Always use {@link org.xmlportletfactory.portal.goodclient.service.userTypesLocalServiceUtil} to access the user types local service.
 * </p>
 *
 * @author Jack A. Rider
 * @see org.xmlportletfactory.portal.goodclient.service.impl.userTypesLocalServiceImpl
 * @see org.xmlportletfactory.portal.goodclient.service.userTypesLocalServiceUtil
 * @generated
 */
public abstract class userTypesLocalServiceBaseImpl
	implements userTypesLocalService {
	/**
	 * Adds the user types to the database. Also notifies the appropriate model listeners.
	 *
	 * @param userTypes the user types to add
	 * @return the user types that was added
	 * @throws SystemException if a system exception occurred
	 */
	public userTypes adduserTypes(userTypes userTypes)
		throws SystemException {
		userTypes.setNew(true);

		return userTypesPersistence.update(userTypes, false);
	}

	/**
	 * Creates a new user types with the primary key. Does not add the user types to the database.
	 *
	 * @param userTypeId the primary key for the new user types
	 * @return the new user types
	 */
	public userTypes createuserTypes(long userTypeId) {
		return userTypesPersistence.create(userTypeId);
	}

	/**
	 * Deletes the user types with the primary key from the database. Also notifies the appropriate model listeners.
	 *
	 * @param userTypeId the primary key of the user types to delete
	 * @throws PortalException if a user types with the primary key could not be found
	 * @throws SystemException if a system exception occurred
	 */
	public void deleteuserTypes(long userTypeId)
		throws PortalException, SystemException {
		userTypesPersistence.remove(userTypeId);
	}

	/**
	 * Deletes the user types from the database. Also notifies the appropriate model listeners.
	 *
	 * @param userTypes the user types to delete
	 * @throws SystemException if a system exception occurred
	 */
	public void deleteuserTypes(userTypes userTypes) throws SystemException {
		userTypesPersistence.remove(userTypes);
	}

	/**
	 * Performs a dynamic query on the database and returns the matching rows.
	 *
	 * @param dynamicQuery the dynamic query to search with
	 * @return the matching rows
	 * @throws SystemException if a system exception occurred
	 */
	@SuppressWarnings("rawtypes")
	public List dynamicQuery(DynamicQuery dynamicQuery)
		throws SystemException {
		return userTypesPersistence.findWithDynamicQuery(dynamicQuery);
	}

	/**
	 * Performs a dynamic query on the database and returns a range of the matching rows.
	 *
	 * <p>
	 * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	 * </p>
	 *
	 * @param dynamicQuery the dynamic query to search with
	 * @param start the lower bound of the range of model instances to return
	 * @param end the upper bound of the range of model instances to return (not inclusive)
	 * @return the range of matching rows
	 * @throws SystemException if a system exception occurred
	 */
	@SuppressWarnings("rawtypes")
	public List dynamicQuery(DynamicQuery dynamicQuery, int start, int end)
		throws SystemException {
		return userTypesPersistence.findWithDynamicQuery(dynamicQuery, start,
			end);
	}

	/**
	 * Performs a dynamic query on the database and returns an ordered range of the matching rows.
	 *
	 * <p>
	 * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	 * </p>
	 *
	 * @param dynamicQuery the dynamic query to search with
	 * @param start the lower bound of the range of model instances to return
	 * @param end the upper bound of the range of model instances to return (not inclusive)
	 * @param orderByComparator the comparator to order the results by
	 * @return the ordered range of matching rows
	 * @throws SystemException if a system exception occurred
	 */
	@SuppressWarnings("rawtypes")
	public List dynamicQuery(DynamicQuery dynamicQuery, int start, int end,
		OrderByComparator orderByComparator) throws SystemException {
		return userTypesPersistence.findWithDynamicQuery(dynamicQuery, start,
			end, orderByComparator);
	}

	/**
	 * Counts the number of rows that match the dynamic query.
	 *
	 * @param dynamicQuery the dynamic query to search with
	 * @return the number of rows that match the dynamic query
	 * @throws SystemException if a system exception occurred
	 */
	public long dynamicQueryCount(DynamicQuery dynamicQuery)
		throws SystemException {
		return userTypesPersistence.countWithDynamicQuery(dynamicQuery);
	}

	/**
	 * Gets the user types with the primary key.
	 *
	 * @param userTypeId the primary key of the user types to get
	 * @return the user types
	 * @throws PortalException if a user types with the primary key could not be found
	 * @throws SystemException if a system exception occurred
	 */
	public userTypes getuserTypes(long userTypeId)
		throws PortalException, SystemException {
		return userTypesPersistence.findByPrimaryKey(userTypeId);
	}

	/**
	 * Gets a range of all the user typeses.
	 *
	 * <p>
	 * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	 * </p>
	 *
	 * @param start the lower bound of the range of user typeses to return
	 * @param end the upper bound of the range of user typeses to return (not inclusive)
	 * @return the range of user typeses
	 * @throws SystemException if a system exception occurred
	 */
	public List<userTypes> getuserTypeses(int start, int end)
		throws SystemException {
		return userTypesPersistence.findAll(start, end);
	}

	/**
	 * Gets the number of user typeses.
	 *
	 * @return the number of user typeses
	 * @throws SystemException if a system exception occurred
	 */
	public int getuserTypesesCount() throws SystemException {
		return userTypesPersistence.countAll();
	}

	/**
	 * Updates the user types in the database. Also notifies the appropriate model listeners.
	 *
	 * @param userTypes the user types to update
	 * @return the user types that was updated
	 * @throws SystemException if a system exception occurred
	 */
	public userTypes updateuserTypes(userTypes userTypes)
		throws SystemException {
		userTypes.setNew(false);

		return userTypesPersistence.update(userTypes, true);
	}

	/**
	 * Updates the user types in the database. Also notifies the appropriate model listeners.
	 *
	 * @param userTypes the user types to update
	 * @param merge whether to merge the user types with the current session. See {@link com.liferay.portal.service.persistence.BatchSession#update(com.liferay.portal.kernel.dao.orm.Session, com.liferay.portal.model.BaseModel, boolean)} for an explanation.
	 * @return the user types that was updated
	 * @throws SystemException if a system exception occurred
	 */
	public userTypes updateuserTypes(userTypes userTypes, boolean merge)
		throws SystemException {
		userTypes.setNew(false);

		return userTypesPersistence.update(userTypes, merge);
	}

	/**
	 * Gets the users local service.
	 *
	 * @return the users local service
	 */
	public usersLocalService getusersLocalService() {
		return usersLocalService;
	}

	/**
	 * Sets the users local service.
	 *
	 * @param usersLocalService the users local service
	 */
	public void setusersLocalService(usersLocalService usersLocalService) {
		this.usersLocalService = usersLocalService;
	}

	/**
	 * Gets the users persistence.
	 *
	 * @return the users persistence
	 */
	public usersPersistence getusersPersistence() {
		return usersPersistence;
	}

	/**
	 * Sets the users persistence.
	 *
	 * @param usersPersistence the users persistence
	 */
	public void setusersPersistence(usersPersistence usersPersistence) {
		this.usersPersistence = usersPersistence;
	}

	/**
	 * Gets the user types local service.
	 *
	 * @return the user types local service
	 */
	public userTypesLocalService getuserTypesLocalService() {
		return userTypesLocalService;
	}

	/**
	 * Sets the user types local service.
	 *
	 * @param userTypesLocalService the user types local service
	 */
	public void setuserTypesLocalService(
		userTypesLocalService userTypesLocalService) {
		this.userTypesLocalService = userTypesLocalService;
	}

	/**
	 * Gets the user types persistence.
	 *
	 * @return the user types persistence
	 */
	public userTypesPersistence getuserTypesPersistence() {
		return userTypesPersistence;
	}

	/**
	 * Sets the user types persistence.
	 *
	 * @param userTypesPersistence the user types persistence
	 */
	public void setuserTypesPersistence(
		userTypesPersistence userTypesPersistence) {
		this.userTypesPersistence = userTypesPersistence;
	}

	/**
	 * Gets the counter local service.
	 *
	 * @return the counter local service
	 */
	public CounterLocalService getCounterLocalService() {
		return counterLocalService;
	}

	/**
	 * Sets the counter local service.
	 *
	 * @param counterLocalService the counter local service
	 */
	public void setCounterLocalService(CounterLocalService counterLocalService) {
		this.counterLocalService = counterLocalService;
	}

	/**
	 * Gets the resource local service.
	 *
	 * @return the resource local service
	 */
	public ResourceLocalService getResourceLocalService() {
		return resourceLocalService;
	}

	/**
	 * Sets the resource local service.
	 *
	 * @param resourceLocalService the resource local service
	 */
	public void setResourceLocalService(
		ResourceLocalService resourceLocalService) {
		this.resourceLocalService = resourceLocalService;
	}

	/**
	 * Gets the resource remote service.
	 *
	 * @return the resource remote service
	 */
	public ResourceService getResourceService() {
		return resourceService;
	}

	/**
	 * Sets the resource remote service.
	 *
	 * @param resourceService the resource remote service
	 */
	public void setResourceService(ResourceService resourceService) {
		this.resourceService = resourceService;
	}

	/**
	 * Gets the resource persistence.
	 *
	 * @return the resource persistence
	 */
	public ResourcePersistence getResourcePersistence() {
		return resourcePersistence;
	}

	/**
	 * Sets the resource persistence.
	 *
	 * @param resourcePersistence the resource persistence
	 */
	public void setResourcePersistence(ResourcePersistence resourcePersistence) {
		this.resourcePersistence = resourcePersistence;
	}

	/**
	 * Gets the user local service.
	 *
	 * @return the user local service
	 */
	public UserLocalService getUserLocalService() {
		return userLocalService;
	}

	/**
	 * Sets the user local service.
	 *
	 * @param userLocalService the user local service
	 */
	public void setUserLocalService(UserLocalService userLocalService) {
		this.userLocalService = userLocalService;
	}

	/**
	 * Gets the user remote service.
	 *
	 * @return the user remote service
	 */
	public UserService getUserService() {
		return userService;
	}

	/**
	 * Sets the user remote service.
	 *
	 * @param userService the user remote service
	 */
	public void setUserService(UserService userService) {
		this.userService = userService;
	}

	/**
	 * Gets the user persistence.
	 *
	 * @return the user persistence
	 */
	public UserPersistence getUserPersistence() {
		return userPersistence;
	}

	/**
	 * Sets the user persistence.
	 *
	 * @param userPersistence the user persistence
	 */
	public void setUserPersistence(UserPersistence userPersistence) {
		this.userPersistence = userPersistence;
	}

	/**
	 * Performs an SQL query.
	 *
	 * @param sql the sql query to perform
	 */
	protected void runSQL(String sql) throws SystemException {
		try {
			DataSource dataSource = userTypesPersistence.getDataSource();

			SqlUpdate sqlUpdate = SqlUpdateFactoryUtil.getSqlUpdate(dataSource,
					sql, new int[0]);

			sqlUpdate.update();
		}
		catch (Exception e) {
			throw new SystemException(e);
		}
	}

	@BeanReference(type = usersLocalService.class)
	protected usersLocalService usersLocalService;
	@BeanReference(type = usersPersistence.class)
	protected usersPersistence usersPersistence;
	@BeanReference(type = userTypesLocalService.class)
	protected userTypesLocalService userTypesLocalService;
	@BeanReference(type = userTypesPersistence.class)
	protected userTypesPersistence userTypesPersistence;
	@BeanReference(type = CounterLocalService.class)
	protected CounterLocalService counterLocalService;
	@BeanReference(type = ResourceLocalService.class)
	protected ResourceLocalService resourceLocalService;
	@BeanReference(type = ResourceService.class)
	protected ResourceService resourceService;
	@BeanReference(type = ResourcePersistence.class)
	protected ResourcePersistence resourcePersistence;
	@BeanReference(type = UserLocalService.class)
	protected UserLocalService userLocalService;
	@BeanReference(type = UserService.class)
	protected UserService userService;
	@BeanReference(type = UserPersistence.class)
	protected UserPersistence userPersistence;
}